From 65cc494c17ac57229078ed1b07fb6469ac85ea24 Mon Sep 17 00:00:00 2001
Message-Id: <65cc494c17ac57229078ed1b07fb6469ac85ea24.1663626215.git.steffen@sdaoden.eu>
In-Reply-To: <ab8b7b45c96ecbcc6c256b987b23ddf281121c2a.1663626215.git.steffen@sdaoden.eu>
References: <ab8b7b45c96ecbcc6c256b987b23ddf281121c2a.1663626215.git.steffen@sdaoden.eu>
From: Steffen Nurpmeso <steffen@sdaoden.eu>
Date: Tue, 20 Sep 2022 00:22:44 +0200
Subject: [PATCH 3/3] tzselect: hack! Also show "the other" -t ZONETYPE result

---
 tzselect.ksh | 68 +++++++++++++++++++++++++++++++++++++++-------------
 1 file changed, 52 insertions(+), 16 deletions(-)

diff --git a/tzselect.ksh b/tzselect.ksh
index 0e00bef5e6..c963660722 100644
--- a/tzselect.ksh
+++ b/tzselect.ksh
@@ -54,7 +54,10 @@ say() {
 
 coord=
 location_limit=10
-zonetabtype=zone1970
+zonetabtype1970=zone1970
+zonetabtypeloc=zone
+zonetabtype=$zonetabtype1970
+zonetabtypex=$zonetabtypeloc
 
 usage="Usage: tzselect [--version] [--help] [-c COORD] [-n LIMIT] [-t ZONETYPE]
 Select a timezone interactively.
@@ -159,7 +162,18 @@ do
     n*)
 	location_limit=$OPTARG ;;
     t*)
-	zonetabtype=$OPTARG ;;
+	if test "$OPTARG" = $zonetabtype1970
+	then
+		zonetabtype=$zonetabtype1970
+		zonetabtypex=$zonetabtypeloc
+	elif test "$OPTARG" = $zonetabtypeloc
+	then
+		zonetabtype=$zonetabtypeloc
+		zonetabtypex=$zonetabtype1970
+	else
+		zonetabtype=$OPTARG
+		zonetabtypex=$zonetabtype1970
+	fi ;;
     -help)
 	exec echo "$usage" ;;
     -version)
@@ -180,7 +194,8 @@ esac
 # Make sure the tables are readable.
 TZ_COUNTRY_TABLE=$TZDIR/iso3166.tab
 TZ_ZONE_TABLE=$TZDIR/$zonetabtype.tab
-for f in $TZ_COUNTRY_TABLE $TZ_ZONE_TABLE
+TZ_ZONE_TABLE_X=$TZDIR/$zonetabtypex.tab
+for f in $TZ_COUNTRY_TABLE $TZ_ZONE_TABLE $TZ_ZONE_TABLE_X
 do
 	<"$f" || {
 		say >&2 "$0: time zone files are not set up correctly"
@@ -201,7 +216,9 @@ $AWK 'BEGIN { u12345 = "\360\222\215\205"; exit length(u12345) != 1 }' || {
         2>/dev/null &&
     TZ_COUNTRY_TABLE=$tmp/iso3166.tab &&
     iconv -f UTF-8 -t //TRANSLIT <"$TZ_ZONE_TABLE" >$tmp/$zonetabtype.tab &&
-    TZ_ZONE_TABLE=$tmp/$zonetabtype.tab
+    TZ_ZONE_TABLE=$tmp/$zonetabtype.tab &&
+    iconv -f UTF-8 -t //TRANSLIT <"$TZ_ZONE_TABLE_X" >$tmp/$zonetabtypex.tab &&
+    TZ_ZONE_TABLE_X=$tmp/$zonetabtypex.tab
 }
 
 newline='
@@ -477,10 +494,11 @@ while
 
 
 		# Get list of timezones in the country.
-		regions=`$AWK \
-			-v country="$country" \
-			-v TZ_COUNTRY_TABLE="$TZ_COUNTRY_TABLE" \
-		'
+		get_region() {
+			$AWK \
+				-v country="$country" \
+				-v TZ_COUNTRY_TABLE="$TZ_COUNTRY_TABLE" \
+			'
 			BEGIN {
 				FS = "\t"
 				cc = country
@@ -493,8 +511,10 @@ while
 			}
 			/^#/ { next }
 			$1 ~ cc { print $4 }
-		' <"$TZ_ZONE_TABLE"`
-
+			'
+		}
+		regions=`get_region < "$TZ_ZONE_TABLE"`
+		regions_x=`get_region < "$TZ_ZONE_TABLE_X"`
 
 		# If there's more than one region, ask the user which one.
 		case $regions in
@@ -505,13 +525,22 @@ while
 		*)
 			region=$regions
 		esac
+		case $regions_x in
+		*"$newline"*)
+			region_x=${regions_x##$newline*};;
+		*)
+			region_x=$regions_x
+			regions_x=
+		esac
+
 
 		# Determine TZ from country and region.
-		TZ=`$AWK \
-			-v country="$country" \
-			-v region="$region" \
-			-v TZ_COUNTRY_TABLE="$TZ_COUNTRY_TABLE" \
-		'
+		get_tz() {
+			$AWK \
+				-v country="$country" \
+				-v region="$1" \
+				-v TZ_COUNTRY_TABLE="$TZ_COUNTRY_TABLE" \
+			'
 			BEGIN {
 				FS = "\t"
 				cc = country
@@ -524,7 +553,10 @@ while
 			}
 			/^#/ { next }
 			$1 ~ cc && $4 == region { print $3 }
-		' <"$TZ_ZONE_TABLE"`
+			'
+		}
+		TZ=`get_tz "$region" < "$TZ_ZONE_TABLE"`
+		TZ_X=`get_tz "$region_x" < "$TZ_ZONE_TABLE_X"`
 		esac
 
 		# Make sure the corresponding zoneinfo file exists.
@@ -571,6 +603,10 @@ Universal Time is now:	$UTdate."
 	esac
 	say >&2 ""
 	say >&2 "Therefore TZ='$TZ' will be used.$extra_info"
+	say >&2 ""
+	test -n "$region_x" && region_x=' region '"$region_x",
+	say >&2 "[-t $zonetabtypex info:$region_x TZs $TZ_X]"
+	say >&2 ""
 	say >&2 "Is the above information OK?"
 
 	doselect Yes No
-- 
2.37.3

